Index: cprs/trunk/CPRS-Chart/fGraphs.pas
===================================================================
--- cprs/trunk/CPRS-Chart/fGraphs.pas	(revision 456)
+++ cprs/trunk/CPRS-Chart/fGraphs.pas	(revision 830)
@@ -4816,347 +5889,179 @@
 end;
 
+procedure TfrmGraphs.BorderValue(var bordervalue: double; value: double);
+begin
+  if FGraphSetting.FixedDateRange then
+    if bordervalue = -BIG_NUMBER then
+      bordervalue := value;
+end;
+
+procedure TfrmGraphs.BPAdd(itemvalue: string; adatetime: TDateTime; var fixeddatevalue: double; serLine, serBPDiastolic, serBPMean: TLineSeries);
+var
+  value: double;
+  valueD, valueM, valueS: string;
+begin
+  valueS := Piece(itemvalue, '/', 1);
+  valueD := Piece(itemvalue, '/', 2);
+  valueM := Piece(itemvalue, '/', 3);
+  value := strtofloatdef(valueS, -BIG_NUMBER);
+  if value <> -BIG_NUMBER then
+    serLine.AddXY(adatetime, value, '', clTeeColor);
+  value := strtofloatdef(valueD, -BIG_NUMBER);
+  if value <> -BIG_NUMBER then
+    serBPDiastolic.AddXY(adatetime, value, '', clTeeColor);
+  value := strtofloatdef(valueM, -BIG_NUMBER);
+  if value <> -BIG_NUMBER then
+  begin
+    serBPMean.AddXY(adatetime, value, '', clTeeColor);
+    serBPMean.Active := true;
+  end;
+  BorderValue(fixeddatevalue, 100);
+end;
+
+procedure TfrmGraphs.BPCheck(aChart: TChart; aFileType: string; serLine, serBPDiastolic, serBPMean: TLineSeries);
+begin
+  MakeSeriesBP(aChart, serLine, serBPDiastolic, aFileType);
+  MakeSeriesBP(aChart, serLine, serBPMean, aFileType);
+  serBPDiastolic.Active := true;
+  serBPMean.Active := false;
+end;
+
+procedure TfrmGraphs.PainAdd(serBlank: TPointSeries);
+begin
+  begin
+    serBlank.Active := true;
+    serBlank.Pointer.Pen.Visible := false;
+    serBlank.AddXY(IncDay(FGraphSetting.LowTime, -1), 0, '', pnlScrollTopBase.Color);
+    serBlank.AddXY(IncDay(FGraphSetting.LowTime, -1), 10, '', pnlScrollTopBase.Color);
+  end;
+end;
+
+procedure TfrmGraphs.NumAdd(serLine: TLineSeries; value: double; adatetime: TDateTime;
+  var fixeddatevalue, hi, lo: double; var high, low: string);
+begin
+  if (btnChangeSettings.Tag = 1) and (hi <> -BIG_NUMBER) and (lo <> -BIG_NUMBER) then
+  begin      // standard deviation
+    value := StdDev(value, hi, lo);
+    serLine.AddXY(adatetime, value, '', clTeeColor);
+    high := '2'; low := '-2';
+    BorderValue(fixeddatevalue, 0);
+    //splGraphs.Tag := 1;   // show ref range
+  end        // inverse value
+  else if btnChangeSettings.Tag = 2 then
+  begin
+    value := InvVal(value);
+    serLine.AddXY(adatetime, value, '', clTeeColor);
+    high := '2'; low := '0';
+    BorderValue(fixeddatevalue, 0);
+    splGraphs.Tag := 0;  // do not show ref range
+  end
+  else
+  begin       // numeric value
+    serLine.AddXY(adatetime, value, '', clTeeColor);
+    BorderValue(fixeddatevalue, value);
+  end;
+end;
+
+procedure TfrmGraphs.NonNumSave(aChart: TChart; aTitle, aSection: string; adatetime: TDateTime;
+  var noncnt: integer; newcnt, aIndex: integer);
+var
+  astring: string;
+begin
+  noncnt := noncnt + 1;
+  astring := floattostr(adatetime) + '^' + inttostr(aChart.Tag) + '^'
+           + inttostr(newcnt) + '^' + inttostr(noncnt) + '^^' + aTitle + '^'
+           + aSection + '^^' + GtslTemp[aIndex];
+  GtslNonNum.Add(astring);
+end;
+
 //****************************************************************************
 
-procedure TfrmGraphs.MakeLineSeries(aChart: TChart; aTitle, aFileType: string; var aSerCnt, aNonCnt: integer; multiline: boolean);
-
-  procedure BorderValue(var bordervalue: double; value: double);
-  begin
-    if FGraphSetting.FixedDateRange then
-      if bordervalue = -BIG_NUMBER then
-        bordervalue := value;
-  end;
-
-var
-  estimate, firstcnt, i, noncnt: integer;
-  value, fixeddatevalue, hi, highestvalue, highvalue, lo, nonvalue: double;
-  checkdata, fmtime, itemvalue, valueD, valueM, valueS: string;
-  high, low, specimen: string;
+procedure TfrmGraphs.MakeLineSeries(aChart: TChart; aTitle, aFileType, section: string;
+  var aSerCnt, aNonCnt: integer; multiline: boolean);
+var
+  i, noncnt, newcnt: integer;
+  value, fixeddatevalue, hi, lo: double;
+  checkdata, fmtime, itemvalue: string;
+  high, low, specimen, comments: string;
   adatetime, adatetime1: TDateTime;
   afixeddate, afixeddate1: TDateTime;
-  ser1, ser2, ser3, serLow, serHigh: TLineSeries;
-  serBlank, serPoint: TPointSeries;
+  serLine, serBPDiastolic, serBPMean, serLow, serHigh: TLineSeries;
+  serBlank: TPointSeries;
 begin
   fixeddatevalue := -BIG_NUMBER;
-  highestvalue := aChart.MaxYValue(aChart.LeftAxis);
-  if highestvalue < 1 then highestvalue := 1;
-  firstcnt := lstNonNumeric.Items.Count;
-  noncnt := firstcnt;
+  noncnt := 0; //GtslNonNum.Count;
   aChart.LeftAxis.LabelsFont.Color := aChart.BottomAxis.LabelsFont.Color;
   aSerCnt := aSerCnt + 1;
-  ser1 := TLineSeries.Create(aChart);
-  ser2 := TLineSeries.Create(aChart);
-  ser3 := TLineSeries.Create(aChart);
-  serPoint := TPointSeries.Create(aChart);
-  serBlank := TPointSeries.Create(aChart);
-  serLow := TLineSeries.Create(aChart);
-  serHigh := TLineSeries.Create(aChart);
   specimen := LowerCase(Piece(aTitle, '^', 4));
-  low := Piece(aTitle, '^', 5);                   // collect non numeric - graph as events
+  low := Piece(aTitle, '^', 5);
   high := Piece(aTitle, '^', 6);
   lo := strtofloatdef(low, -BIG_NUMBER);
   hi := strtofloatdef(high, -BIG_NUMBER);
+  serLine := TLineSeries.Create(aChart);
+  newcnt := aChart.SeriesCount;
+  serBPDiastolic := TLineSeries.Create(aChart);
+  serBPMean := TLineSeries.Create(aChart);
+  serLow := TLineSeries.Create(aChart);
   serLow.Active := false;
+  serHigh := TLineSeries.Create(aChart);
   serHigh.Active := false;
-  serPoint.Active := false;
+  serBlank := TPointSeries.Create(aChart);
   serBlank.Active := false;
-  with ser1 do
-  begin
+  with serLine do
+  begin
+    MakeSeriesInfo(aChart, serLine, aTitle, aFileType, aSerCnt);
     LinePen.Visible := FGraphSetting.Lines;
-    ParentChart := aChart;
-    Title := Piece(aTitle, '^', 3);
     if (length(specimen) > 0) and (not ansicontainsstr(Title, specimen)) then
       Title := Title + ' (' + specimen + ')';
-    XValues.DateTime := True;
-    NextPointerStyle(ser1, aSerCnt);
-    Identifier := aFileType;
     Pointer.Visible := true;
     Pointer.InflateMargins := true;
-    GetData(aTitle);
-    ColorEachPoint := false;
-    SeriesColor := NextColor(aSerCnt);
-    Marks.BackColor := clInfoBk;
-    if ser1.Title = 'Blood Pressure' then
-    begin
-      ser1.Title := 'Blood Pressure';
-      with ser2 do
+    NextPointerStyle(serLine, aSerCnt);
+    Tag := newcnt;
+  end;
+  if serLine.Title = 'Blood Pressure' then
+    BPCheck(aChart, aFileType, serLine, serBPDiastolic, serBPMean);
+  for i:= 0 to GtslTemp.Count - 1 do
+  begin
+    checkdata := GtslTemp[i];
+    fmtime := FMCorrectedDate(Piece(checkdata, '^', 3));
+    if IsFMDateTime(fmtime) then
+    begin
+      HighLow(fmtime, '', aChart, adatetime, adatetime1);
+      comments := Piece(checkdata, '^', 9);
+      if strtointdef(comments, -1) > 0  then aChart.Hint := comments;  // for any occurrence
+      itemvalue := Piece(checkdata, '^', 5);
+      itemvalue := trim(itemvalue);
+      itemvalue := StringReplace(itemvalue, ',', '', [rfReplaceAll]);
+      if serLine.Title = 'Blood Pressure' then
+        BPAdd(itemvalue, adatetime, fixeddatevalue, serLine, serBPDiastolic, serBPMean)
+      else
       begin
-        ParentChart := aChart;
-        Title := 'Blood Pressure';
-        XValues.DateTime := true;
-        Pointer.Style := ser1.Pointer.Style;
-        ShowInLegend := false;    //****
-        Identifier := aFileType;
-        Pointer.Visible := true;
-        Pointer.InflateMargins := true;
-        ColorEachPoint := false;
-        SeriesColor := ser1.SeriesColor;
-        Marks.BackColor := clInfoBk;
-        Active := true;
+        value := strtofloatdef(itemvalue, -BIG_NUMBER);
+        if value <> -BIG_NUMBER then
+          NumAdd(serLine, value, adatetime, fixeddatevalue, hi, lo, high, low)
+        else
+          NonNumSave(aChart, serLine.Title, section, adatetime, noncnt, newcnt, i);
       end;
-      with ser3 do
-      begin
-        ParentChart := aChart;
-        Title := 'Blood Pressure';
-        XValues.DateTime := true;
-        Pointer.Style := ser1.Pointer.Style;
-        ShowInLegend := false;   //****
-        Identifier := aFileType;
-        Pointer.Visible := true;
-        Pointer.InflateMargins := true;
-        ColorEachPoint := false;
-        SeriesColor := ser1.SeriesColor;
-        Marks.BackColor := clInfoBk;
-        Active := false;
-      end;
-    end
-    else
-    begin
-      ser2.Active := false;
-      ser3.Active := false;
-    end;
-    highvalue := 0;
-    with lstTemp do
-    for i:= 0 to Items.Count - 1 do
-    begin
-      checkdata := lstTemp.Items[i];
-      fmtime := FMCorrectedDate(Piece(Items[i], '^', 3));
-      if IsFMDateTime(fmtime) then
-      begin
-        HighLow(fmtime, '', aChart, adatetime, adatetime1);
-        itemvalue := Piece(Items[i], '^', 5);
-        itemvalue := trim(itemvalue);
-        itemvalue := StringReplace(itemvalue, ',', '', [rfReplaceAll]);
-        if ser1.Title = 'Blood Pressure' then
-        begin
-          valueS := Piece(itemvalue, '/', 1);
-          valueD := Piece(itemvalue, '/', 2);
-          valueM := Piece(itemvalue, '/', 3);
-          value := strtofloatdef(valueS, -BIG_NUMBER);
-          if value <> -BIG_NUMBER then
-            ser1.AddXY(adatetime, value, '', clTeeColor);
-          value := strtofloatdef(valueD, -BIG_NUMBER);
-          if value <> -BIG_NUMBER then
-            ser2.AddXY(adatetime, value, '', clTeeColor);
-          value := strtofloatdef(valueM, -BIG_NUMBER);
-          if value <> -BIG_NUMBER then
-          begin
-            ser3.AddXY(adatetime, value, '', clTeeColor);
-            ser3.Active := true;
-          end;
-          BorderValue(fixeddatevalue, 100);
-        end
-        else
-        begin
-          value := strtofloatdef(itemvalue, -BIG_NUMBER);
-          if value <> -BIG_NUMBER then
-          begin
-            if (btnChangeSettings.Tag = 1) and (hi <> -BIG_NUMBER) and (lo <> -BIG_NUMBER) then
-            begin
-              value := StdDev(value, hi, lo);
-              ser1.AddXY(adatetime, value, '', clTeeColor);
-              high := '2'; low := '-2';
-              BorderValue(fixeddatevalue, 0);
-              //splGraphs.Tag := 1;   // show ref range
-            end
-            else if btnChangeSettings.Tag = 2 then
-            begin
-              value := InvVal(value);
-              ser1.AddXY(adatetime, value, '', clTeeColor);
-              high := '2'; low := '0';
-              BorderValue(fixeddatevalue, 0);
-              splGraphs.Tag := 0;  // do not show ref range
-            end
-            else
-            begin
-              ser1.AddXY(adatetime, value, '', clTeeColor);
-              if value > highvalue then
-                highvalue := value;
-              BorderValue(fixeddatevalue, value);
-            end;
-          end
-          else
-          begin
-            noncnt := noncnt + 1;
-            lstNonNumeric.Items.Add(floattostr(adatetime) + '^' +
-              itemvalue + '^' + inttostr(aNonCnt + 1));
-          end;
-        end;
-      end;
-    end;
-    if (length(low) > 0) and (splGraphs.Tag = 1) then
-    begin
-      with serLow do
-      begin
-        Active := true;
-        ParentChart := aChart;
-        XValues.DateTime := True;
-        Pointer.Visible := false;
-        Pointer.InflateMargins := true;
-        OnGetMarkText := serDatelineTop.OnGetMarkText;
-        ColorEachPoint := false;
-        Title := 'Ref Low ' + low;
-        Pointer.Style := psCircle;
-        SeriesColor := ser1.SeriesColor; //clBtnShadow ; //clTeeColor;
-        Marks.Visible := false;
-        LinePen.Visible := true;
-        LinePen.Width := 2;
-        LinePen.Style := psDash;  //does not show when width <> 1
-      end;
-      value := strtofloatdef(low, -BIG_NUMBER);
-      if value <> -BIG_NUMBER then
-      begin
-        serLow.AddXY(IncDay(FGraphSetting.LowTime, -1), value, '', clTeeColor);
-        serLow.AddXY(IncDay(FGraphSetting.HighTime, 1), value, '', clTeeColor);
-        BorderValue(fixeddatevalue, value);
-      end;
-    end;
-    if (length(high) > 0) and (splGraphs.Tag = 1) then
-    begin
-      with serHigh do
-      begin
-        Active := true;
-        ParentChart := aChart;
-        XValues.DateTime := True;
-        Pointer.Visible := false;
-        Pointer.InflateMargins := true;
-        OnGetMarkText := serDatelineTop.OnGetMarkText;
-        ColorEachPoint := false;
-        Title := 'Ref High ' + high;
-        Pointer.Style := psCircle;
-        SeriesColor := ser1.SeriesColor; // clBtnShadow; //clTeeColor;
-        Marks.Visible := false;
-        LinePen.Visible := true;
-        LinePen.Width := 2;
-        LinePen.Style := psDash;  //does not show when width <> 1
-      end;
-      value := strtofloatdef(high, -BIG_NUMBER);
-      if value <> -BIG_NUMBER then
-      begin
-        serHigh.AddXY(IncDay(FGraphSetting.LowTime, -1), value, '', clTeeColor);
-        serHigh.AddXY(IncDay(FGraphSetting.HighTime, 1), value, '', clTeeColor);
-        BorderValue(fixeddatevalue, value);
-      end;
-    end;
-    splGraphs.Tag := 0;
-    if noncnt > firstcnt then
-    begin
-      if aChart.Height < 10 then estimate := pnlMain.Height div 2
-      else estimate := aChart.Height;
-      aNonCnt := aNonCnt + 1;  // use nonnumeric count to offset position
-      nonvalue := (aNonCnt * (10 / (estimate + 1)) * highestvalue);
-      with serBlank do
-      begin
-        Active := true;
-        ParentChart := aChart;
-        XValues.DateTime := True;
-        Pointer.Visible := true;
-        Pointer.InflateMargins := true;
-        OnGetMarkText := serDatelineTop.OnGetMarkText;
-        ColorEachPoint := false;
-        Title := '';
-        Pointer.Style := psSmallDot;
-        SeriesColor := aChart.Color;
-        Marks.Visible := false;
-        ShowInLegend := false;
-      end;
-      with serPoint do
-      begin
-        Active := true;
-        ParentChart := aChart;
-        XValues.DateTime := True;
-        Pointer.Visible := true;
-        Pointer.InflateMargins := true;
-        OnGetMarkText := serDatelineTop.OnGetMarkText;
-        ColorEachPoint := false;
-        Title := '(non-numeric)';
-        Hint := aTitle;
-        Tag := aNonCnt;
-        Pointer.Style := ser1.Pointer.Style;
-        SeriesColor := ser1.SeriesColor;
-        Marks.BackColor := clInfoBk;
-        ShowInLegend := false;
-      end;
-      for i := 0 to lstNonNumeric.Items.Count - 1 do
-      begin
-        if Piece(lstNonNumeric.Items[i], '^',3) = inttostr(aNonCnt) then
-        if highvalue = 0 then
-        begin
-          adatetime := strtofloatdef(Piece(lstNonNumeric.Items[i], '^', 1), -BIG_NUMBER);
-          if adatetime <> -BIG_NUMBER then
-          begin
-            serBlank.Pointer.Pen.Visible := false;
-            serBlank.AddXY(adatetime, 1, '', pnlScrollTopBase.Color);
-            break;
-          end;
-        end;
-      end;
-      for i := 0 to lstNonNumeric.Items.Count - 1 do
-      if Piece(lstNonNumeric.Items[i], '^',3) = inttostr(aNonCnt) then
-      begin
-        adatetime := strtofloatdef(Piece(lstNonNumeric.Items[i], '^', 1), -BIG_NUMBER);
-        if adatetime <> -BIG_NUMBER then
-        begin
-          serPoint.Pointer.Pen.Visible := true;
-          serPoint.AddXY(adatetime, nonvalue, '', ser1.SeriesColor);
-          BorderValue(fixeddatevalue, nonvalue);
-        end;
-      end;
-      if highvalue = 0 then
-      begin
-        aChart.LeftAxis.LabelsFont.Color := pnlScrollTopBase.Color;
-        FNonNumerics := true;
-      end;
-    end;
-    if ser1.Title = 'Pain' then
-    begin
-      if not serBlank.Active then
-      with serBlank do
-      begin
-        Active := true;
-        ParentChart := aChart;
-        XValues.DateTime := True;
-        Pointer.Visible := true;
-        Pointer.InflateMargins := true;
-        OnGetMarkText := serDatelineTop.OnGetMarkText;
-        ColorEachPoint := false;
-        Title := '';
-        Pointer.Style := psSmallDot;
-        SeriesColor := aChart.Color;
-        Marks.Visible := false;
-        ShowInLegend := false;
-      end;
-      serBlank.Pointer.Pen.Visible := false;
-      serBlank.AddXY(IncDay(FGraphSetting.LowTime, -1), 0, '', pnlScrollTopBase.Color);
-      serBlank.AddXY(IncDay(FGraphSetting.LowTime, -1), 10, '', pnlScrollTopBase.Color);
-    end;
-    if multiline then
-    begin
-      // do nothing for now
-    end;
-    if fixeddatevalue <> -BIG_NUMBER then
-    begin
-      if not serBlank.Active then
-      with serBlank do
-      begin
-        Active := true;
-        ParentChart := aChart;
-        XValues.DateTime := True;
-        Pointer.Visible := true;
-        Pointer.InflateMargins := true;
-        OnGetMarkText := serDatelineTop.OnGetMarkText;
-        ColorEachPoint := false;
-        Title := '';
-        Pointer.Style := psSmallDot;
-        SeriesColor := aChart.Color;
-        Marks.Visible := false;
-        ShowInLegend := false;
-      end;
-      FixedDates(afixeddate, afixeddate1);
-      serBlank.Pointer.Pen.Visible := false;
-      serBlank.AddXY(afixeddate, fixeddatevalue, '', aChart.Color);
-      serBlank.AddXY(afixeddate1, fixeddatevalue, '', aChart.Color);
-    end;
-    GetHorizAxis.ExactDateTime := True;
-    GetHorizAxis.Increment := DateTimeStep[dtOneMinute];
+    end;
+  end;
+  if (length(low) > 0) and (splGraphs.Tag = 1) then
+    MakeSeriesRef(aChart, serLine, serLow, 'Ref Low ', low, fixeddatevalue);
+  if (length(high) > 0) and (splGraphs.Tag = 1) then
+    MakeSeriesRef(aChart, serLine, serHigh, 'Ref High ', high, fixeddatevalue);
+  splGraphs.Tag := 0;
+  MakeSeriesPoint(aChart, serBlank);
+  if serLine.Title = 'Pain' then
+    PainAdd(serBlank);
+  if multiline then
+  begin
+    // do nothing for now
+  end;
+  if fixeddatevalue <> -BIG_NUMBER then
+  begin
+    serBlank.Active := true;
+    serBlank.Pointer.Pen.Visible := false;
+    FixedDates(afixeddate, afixeddate1);
+    serBlank.AddXY(afixeddate, fixeddatevalue, '', aChart.Color);
+    serBlank.AddXY(afixeddate1, fixeddatevalue, '', aChart.Color);
   end;
 end;
@@ -5168,41 +6073,33 @@
   fmtime: string;
   adatetime, adatetime1: TDateTime;
-  ser1: TPointSeries;
+  serPoint: TPointSeries;
 begin
   aSerCnt := aSerCnt + 1;
-  ser1 := TPointSeries.Create(aChart);
-  with ser1 do
-  begin
-    ParentChart := aChart;
-    Title := Piece(aTitle, '^', 3);
-    OnGetMarkText := serDatelineTop.OnGetMarkText;
-    XValues.DateTime := True;
-    NextPointerStyle(ser1, aSerCnt);
+  serPoint := TPointSeries.Create(aChart);
+  MakeSeriesInfo(aChart, serPoint, aTitle, aFileType, aSerCnt);
+  with serPoint do
+  begin
+    NextPointerStyle(serPoint, aSerCnt);
+    Pointer.Visible := true;
+    Pointer.InflateMargins := true;
+    Pointer.Style := psSmallDot;
+    Pointer.Pen.Visible := true;
     Pointer.VertSize := 10;
     Pointer.HorizSize := 2;
-    Identifier := aFileType;
-    Pointer.Visible := true;
-    GetData(aTitle);
-    ColorEachPoint := false;
-    SeriesColor := NextColor(aSerCnt);
-    Marks.BackColor := clInfoBk;
-    with lstTemp do
-    for i := 0 to lstTemp.Items.Count - 1 do
-    begin
-      fmtime := FMCorrectedDate(Piece(Items[i], '^', 3));
+    for i := 0 to GtslTemp.Count - 1 do
+    begin
+      fmtime := FMCorrectedDate(Piece(GtslTemp[i], '^', 3));
       if IsFMDateTime(fmtime) then
       begin
         HighLow(fmtime, '', aChart, adatetime, adatetime1);
-        value := strtofloatdef(Piece(Items[i], '^', 5), -BIG_NUMBER);
+        value := strtofloatdef(Piece(GtslTemp[i], '^', 5), -BIG_NUMBER);
         if value = -BIG_NUMBER then
         begin
           value := aSerCnt;
-          TempCheck(Pieces(Items[i], '^', 1, 2), value);
+          TempCheck(Pieces(GtslTemp[i], '^', 1, 2), value);
         end;
-        ser1.AddXY(adatetime, value, '', clTeeColor);
+        serPoint.AddXY(adatetime, value, '', clTeeColor);
       end;
     end;
-    GetHorizAxis.ExactDateTime := True;
-    GetHorizAxis.Increment := DateTimeStep[dtOneMinute];
   end;
 end;
@@ -5215,45 +6112,20 @@
   adatetime, adatetime1: TDateTime;
   afixeddate, afixeddate1: TDateTime;
-  ser1: TBarSeries;
+  serBar: TBarSeries;
   serBlank: TPointSeries;
 begin
   aSerCnt := aSerCnt + 1;
-  ser1 := TBarSeries.Create(aChart);
   serBlank := TPointSeries.Create(aChart);
-  with serBlank do
-  begin
-    Active := true;
-    ParentChart := aChart;
-    XValues.DateTime := True;
-    Pointer.Visible := true;
-    Pointer.InflateMargins := false;
-    ColorEachPoint := false;
-    Title := '';
-    Pointer.Style := psSmallDot;
-    OnGetMarkText := serDatelineTop.OnGetMarkText;
-    SeriesColor := aChart.Color;
-    Marks.BackColor := clInfoBk;
-    ShowInLegend := false;
-  end;
-  with ser1 do
-  begin
-    ParentChart := aChart;
-    Title := Piece(aTitle, '^', 3);
-    XValues.DateTime := True;
+  MakeSeriesPoint(aChart, serBlank);
+  serBar := TBarSeries.Create(aChart);
+  MakeSeriesInfo(aChart, serBar, aTitle, aFileType, aSerCnt);
+  with serBar do
+  begin
     YOrigin := 0;
-    Identifier := aFileType;
-    Marks.Visible := false;
-    OnGetMarkText := serDatelineTop.OnGetMarkText;
     CustomBarWidth := 7;
-    Marks.Style := smsLabel;
-    GetData(aTitle);
-    ColorEachPoint := false;
-    SeriesColor := NextColor(aSerCnt);
-    Marks.BackColor := clInfoBk;
-    NextPointerStyle(ser1, aSerCnt);
-    with lstTemp do
-    for i:= 0 to Items.Count - 1 do
-    begin
-      fmtime := FMCorrectedDate(Piece(Items[i], '^', 3));
+    NextPointerStyle(serBar, aSerCnt);
+    for i:= 0 to GtslTemp.Count - 1 do
+    begin
+      fmtime := FMCorrectedDate(Piece(GtslTemp[i], '^', 3));
       if IsFMDateTime(fmtime) then
       begin
@@ -5263,12 +6135,10 @@
           if copy((FPrevEvent + '00'), 1, 12) = copy(fmtime, 1, 12) then  // same time occurrence
           begin
-            pnlInfo.Caption := TXT_WARNING_SAME_TIME;
-            pnlInfo.Color := COLOR_WARNING;
-            pnlInfo.Visible := true;
+            InfoMessage(TXT_WARNING_SAME_TIME, COLOR_WARNING, true);
             pnlHeader.Visible := true;
             FWarning := true;
           end;
         if value <> -BIG_NUMBER then
-          ser1.AddXY(adatetime, value, '', clTeeColor);
+          serBar.AddXY(adatetime, value, '', clTeeColor);
         FPrevEvent := copy(fmtime, 1, 10);
         if i = 0 then
@@ -5285,10 +6155,8 @@
       end;
     end;
-    GetHorizAxis.ExactDateTime := True;
-    GetHorizAxis.Increment := DateTimeStep[dtOneMinute];
-  end;
-end;
-
-procedure TfrmGraphs.MakeManyGanttSeries(aChart: TChart; aTitle, aFileType: string; var aSerCnt: integer);
+  end;
+end;
+
+procedure TfrmGraphs.MakeGanttSeries(aChart: TChart; aTitle, aFileType: string; var aSerCnt: integer);
 var
   i, value: integer;
@@ -5296,31 +6164,14 @@
   adatetime, adatetime1: TDateTime;
   afixeddate, afixeddate1: TDateTime;
-  gantt: TGanttSeries;
+  serGantt: TGanttSeries;
   serBlank: TPointSeries;
 begin
   aSerCnt := aSerCnt + 1;
-  gantt := TGanttSeries.Create(aChart);
   serBlank := TPointSeries.Create(aChart);
-  with serBlank do
-  begin
-    Active := true;
-    ParentChart := aChart;
-    XValues.DateTime := True;
-    Pointer.Visible := true;
-    Pointer.InflateMargins := false;
-    ColorEachPoint := false;
-    Title := '';
-    Pointer.Style := psSmallDot;
-    OnGetMarkText := serDatelineTop.OnGetMarkText;
-    SeriesColor := aChart.Color;
-    Marks.BackColor := clInfoBk;
-    ShowInLegend := false;
-  end;
-  with gantt do
-  begin
-    ParentChart := aChart;
-    Title := Piece(aTitle, '^', 3);
-    Marks.Style := smsLabel;
-    OnGetMarkText := serDatelineTop.OnGetMarkText;
+  MakeSeriesPoint(aChart, serBlank);
+  serGantt := TGanttSeries.Create(aChart);
+  MakeSeriesInfo(aChart, serGantt, aTitle, aFileType, aSerCnt);
+  with serGantt do
+  begin
     if Piece(aTitle, '^', 1) = '55' then       // make inpatient meds smaller to identify
       Pointer.VertSize := RX_HEIGHT_IN
@@ -5331,19 +6182,13 @@
     else
       Pointer.VertSize := RX_HEIGHT_OUT;
-    GetData(aTitle);
-    ColorEachPoint := false;
-    SeriesColor := NextColor(aSerCnt);
-    Identifier := aFileType;
-    Marks.BackColor := clInfoBk;
     value := round(((aSerCnt mod NUM_COLORS) / NUM_COLORS) * 80) + 20 + aSerCnt;
     if aFileType <> '9999911' then
       if aChart <> chartDatelineTop then
         if aChart <> chartDatelineBottom then
-      value := value - 26;
-    with lstTemp do
-    for i := 0 to lstTemp.Items.Count - 1 do
-    begin
-      fmtime := FMCorrectedDate(Piece(Items[i], '^', 3));
-      fmtime1 := FMCorrectedDate(Piece(Items[i], '^', 4));
+          value := value - 26;
+    for i := 0 to GtslTemp.Count - 1 do
+    begin
+      fmtime := FMCorrectedDate(Piece(GtslTemp[i], '^', 3));
+      fmtime1 := FMCorrectedDate(Piece(GtslTemp[i], '^', 4));
       if IsFMDateTime(fmtime) and IsFMDateTime(fmtime1) then
       begin
@@ -5365,6 +6210,4 @@
       end;
     end;
-    GetHorizAxis.ExactDateTime := True;
-    GetHorizAxis.Increment := DateTimeStep[dtOneMinute];
   end;
 end;
@@ -5377,31 +6220,14 @@
   adatetime, adatetime1: TDateTime;
   afixeddate, afixeddate1: TDateTime;
-  gantt: TGanttSeries;
+  serGantt: TGanttSeries;
   serBlank: TPointSeries;
 begin
   aSerCnt := aSerCnt + 1;
-  gantt := TGanttSeries.Create(aChart);
   serBlank := TPointSeries.Create(aChart);
-  with serBlank do
-  begin
-    Active := true;
-    ParentChart := aChart;
-    XValues.DateTime := True;
-    Pointer.Visible := true;
-    Pointer.InflateMargins := false;
-    ColorEachPoint := false;
-    Title := '';
-    Pointer.Style := psSmallDot;
-    OnGetMarkText := serDatelineTop.OnGetMarkText;
-    SeriesColor := aChart.Color;
-    Marks.Visible := false;
-    ShowInLegend := false;
-  end;
-  with gantt do
-  begin
-    ParentChart := aChart;
-    Title := Piece(aTitle, '^', 3);
-    Marks.Style := smsLabel;
-    OnGetMarkText := serDatelineTop.OnGetMarkText;
+  MakeSeriesPoint(aChart, serBlank);
+  serGantt := TGanttSeries.Create(aChart);
+  MakeSeriesInfo(aChart, serGantt, aTitle, aFileType, aSerCnt);
+  with serGantt do
+  begin
     if Piece(aTitle, '^', 1) = '405' then  // make admit smaller to identify
       Pointer.VertSize := NUM_COLORS + 3
@@ -5410,15 +6236,9 @@
     else
       Pointer.VertSize := NUM_COLORS + (aSerCnt mod NUM_COLORS) + 10;
-    GetData(aTitle);
-    ColorEachPoint := false;
-    SeriesColor := NextColor(aSerCnt);
-    Identifier := aFileType;
-    Marks.BackColor := clInfoBk;
     value := aSerCnt div NUM_COLORS;
-    with lstTemp do
-    for i:= 0 to Items.Count - 1 do
-    begin
-      fmtime := FMCorrectedDate(Piece(Items[i], '^', 3));
-      fmtime1 := FMCorrectedDate(Piece(Items[i], '^', 4));
+    for i:= 0 to GtslTemp.Count - 1 do
+    begin
+      fmtime := FMCorrectedDate(Piece(GtslTemp[i], '^', 3));
+      fmtime1 := FMCorrectedDate(Piece(GtslTemp[i], '^', 4));
       if IsFMDateTime(fmtime) and IsFMDateTime(fmtime1) then
       begin
